Bug 996692 - virtio-serial: write() call does not always block when host is not connected
virtio-serial: write() call does not always block when host is not connected
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: qemu (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Fedora Virtualization Maintainers
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-13 13:54 EDT by Jonathan Lebon
Modified: 2015-02-17 11:45 EST (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 11:45:05 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
host.c and guest.c (2.08 KB, text/plain)
2013-08-13 13:54 EDT, Jonathan Lebon
no flags Details

  None (edit)
Description Jonathan Lebon 2013-08-13 13:54:32 EDT
Created attachment 786228 [details]
host.c and guest.c

Description of problem:

The Guest API for virtio-serial (http://www.linux-kvm.org/page/Virtio-serial_API) indicates that a write(2) call will block if no host app is connected to the socket. However, under certain conditions, this does not happen. If a host app was INTerrupted and subsequently terminated during a read() call, the following write() call in the guest app will succeed.

Version-Release number of selected component (if applicable):

Fedora 19 x86_64 with qemu-kvm-1.4.2-4

How reproducible:

Every time

Steps to Reproduce:

The steps assume your VM is configured with a virtio-serial port named foobar.

1. Compile host.c and run on host machine, it will block on read()
2. Interrupt (^C) the application to terminate it
3. Compile guest.c and run on guest machine

Actual results:

The write() call in the guest app succeeds.

Expected results:

The write() call in the guest app blocks because no host app is connected to the socket.
Comment 1 Amit Shah 2013-08-16 04:29:40 EDT
qemu doesn't get the notification that a host-side process is terminated (and hence the socket is disconnected).  This is a limitation of the qemu's chardev layer, and a difficult one to fix in general.  This is a known problem, but we can't say when it'll be resolved.

BTW subsequent guest writes will block.
Comment 2 Fedora End Of Life 2015-01-09 14:26:27 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2015-02-17 11:45:05 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.